<template>
  <div>
    <ag-grid-vue
      :row-data="dataSource"
      :grid-options="options"
      :column-defs="columns"
      :context="gridContext"
      :modules="modules"
      @grid-ready="onGridReady"
      @cellClicked="onCellClicked"
      @selectionChanged="onSelectionChanged"
      class="ag-theme-material"
      style="height: 100%"
    />
  </div>
</template>

<script>
import { AgGridVue } from '@ag-grid-community/vue'
import { AllCommunityModules } from '@ag-grid-community/all-modules'
import { mixin, mixinDevice } from '@/utils/mixin'
import NoRowsOverlay from './NoRowsOverlay.vue'

const checkboxCol = {
  headerCheckboxSelection: true,
  headerCheckboxSelectionFilteredOnly: true,
  checkboxSelection: true,
  pinned: 'left',
  width: 70
}

export default {
  components: {
    'ag-grid-vue': AgGridVue
  },
  mixins: [mixin, mixinDevice],
  props: {
    gridContext: {
      type: Object,
      default: () => {}
    },
    rowData: {
      type: Array,
      default: () => []
    },
    columnDefs: {
      type: Array,
      default: () => []
    },
    gridOptions: {
      type: Object,
      default: () => {}
    },
    enableCheckbox: {
      type: Boolean,
      default: () => true
    }
  },
  data () {
    return {
      modules: AllCommunityModules
    }
  },
  computed: {
    dataSource () {
      return this.rowData
    },
    columns () {
      // This is a magic
      return ((this.enableCheckbox && [checkboxCol]) || []).concat(...this.columnDefs)
    },
    options () {
      return {
        suppressRowClickSelection: true,
        suppressCellSelection: true,
        enableCellTextSelection: true,
        suppressDragLeaveHidesColumns: true,
        rowSelection: 'multiple',
        domLayout: 'autoHeight',
        defaultColDef: {
          resizable: true,
          sortable: true,
          autoHeight: true,
          minWidth: 60,
          width: 200,
          cellClass: 'cell-wrap-text'
        },
        noRowsOverlayComponentFramework: NoRowsOverlay,
        ...this.gridOptions
      }
    }
  },

  methods: {
    onSelectionChanged (e) {
      this.$emit('selectionChanged', e)
    },
    onCellClicked (e) {
      this.$emit('cellClicked', e)
    },
    refresh (params) {
      this.params = params
      console.log(this.params)
      return true
    },
    onGridReady (params) {
      this.gridApi = params.api
      this.columnApi = params.columnApi
      //   this.gridApi.setDomLayout("autoHeight");
    }
  }
}
</script>

<style lang="less">
.cell-wrap-text {
  white-space: normal !important;
}
.cell-wrapper-grid-content {
  p {
    margin-bottom: 0px;
    padding-left: 4px;
    position: relative;
    line-height: 30px;
  }
}
</style>
